import { Text, View, StyleSheet, TouchableOpacity } from 'react-native'
import React, { Component } from 'react'

import calcLogic from '../ClacLogic';

export default class KeyboardView extends Component {
    constructor(props) {
        super(props);
    }
    
    render() {
        return (
            <View style={styles.cont}>
            {
                keyboard.map((row, rowIndex) => (
                    <View style={styles.row} key={rowIndex}>
                    {
                        row.map((col, colIndex) => {
                            if(this.props.portait && colIndex < 2) return;
                            let style = colIndex == 5 ? styles.key2 : styles.key;
                            return (
                                <TouchableOpacity style={style} key={colIndex} onPress={this.onKeyTap.bind(this, col)}>
                                <Text style={styles.keyText}>{col}</Text>
                                </TouchableOpacity>
                            )
                        })
                    }
                    </View>
                ))
            }
            </View>
        )
    }

    onKeyTap(key) {
        switch(key) {
            case 'C':
            calcLogic.clear();
            break;
            case '⌫':
            calcLogic.deleteLastChar();
            break;
            case '=':
            //calcLogic.calculate();
            break;
            default:
            calcLogic.append(key);
            break;
        }
        if(addBracketTo.includes(key)) {
            calcLogic.append('(');
        }
        calcLogic.calculate();

        this.props.onKeyTap();
    }
}
            
const styles = StyleSheet.create({
    cont: {
        
    },
    row: {
        flexDirection: 'row',
    },
    key: {
        flex: 1,
        margin: 1,
        padding: 20,
        backgroundColor: '#333',
    },
    key2: {
        flex: 1,
        margin: 1,
        padding: 20,
        backgroundColor: '#a33',
    },
    keyText: {
        textAlign: 'center',
        fontSize: 24,
        color: '#eee'
    }
});

const keyboard = [
    ['√', '(', 'C', '⌫', '%', '÷'],
    ['^', ')', '7', '8', '9', '×'],
    ['sin', 'π', '4', '5', '6', '−'],
    ['cos', 'e', '1', '2', '3', '+'],
    ['tg', 'ln', '000', '0', '.', '='],
];

const addBracketTo = [
    'sin', 'cos', 'tg', 'ln', '√'
]